/* qksort - sort array a (dimension n) using quicksort */
#include "local.h"
/* iqksort - internal function to partition the array [*lo:*hi] */
static void iqksort(p_lo, p_hi)
	short *p_lo, *p_hi;
	{
	short *p_mid = p_lo + (p_hi - p_lo) / 2;	/* : {p_lo:p_hi} */
	short *p_i;									/* : {p_lo+1:p_hi+1} */
	short *p_lastlo;							/* : {p_lo:p_hi-1} */
	short tmp;

	SWAP(*p_lo, *p_mid, tmp);
	p_lastlo = p_lo;
	for (p_i = p_lo+1; p_i <= p_hi; ++p_i)
		{
		if (*p_lo > *p_i)
			{
			++p_lastlo;
			SWAP(*p_lastlo, *p_i, tmp);
			}
		}
	SWAP(*p_lo, *p_lastlo, tmp);
	if (p_lo < p_lastlo && p_lo < p_lastlo - 1)
		iqksort(p_lo, p_lastlo - 1);
	if (p_lastlo + 1 < p_hi)
		iqksort(p_lastlo + 1, p_hi);
	}
/* qksort - external entry point */
void qksort(a, n)
	short a[];	/* array to be sorted; a[0:n-1]: multiset */
	size_t n;	/* number of elements */
	{
	if (n > 1)
		iqksort(a, &a[n-1]);
	}
